/*   pci.ids  to pcidevs.txt filter */
/*
 *    Copyright (C) 2012   Greg Jarvis
 *
 *    This program is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
ver = '1.00'
verids = '?'
in  = 'pci.ids'
out = 'pcidevs.txt'
tab = d2c(9)

'@echo off'
call stream in,'c','open read'
call stream out,'c','open write replace'

call lineout out,"; This file has been auto converted to Craig Hart's format by pcidevs.cmd vers" ver
vendor = 'V'
device = 'D'

do while lines(in)
   line = linein(in)

   select
      when length(line)=0 then line = ';'line
      when left(line,1)='#' then do
         line = ';'line
         if left(line,10)='#'||tab||"Version:" then verids = word(line,3)
         end
      when left(line,2)=tab||tab then line = ';'line
      when left(line,1)=tab then do    /* device */
         parse var line (tab) id name
         line = device||tab||translate(id)||tab||name
         end
      otherwise  do                    /* vendor */
         parse var line id name
         if id='C' then do
            vendor = 'C'
            device = 'T'
            parse var name id name
            end
         line = vendor||tab||translate(id)||tab||name
         end
   end

   say line
   call lineout out,line
end

call stream in,'c','close'
call stream out,'c','close'
'@echo on'

say "pcidevs script version" ver
say "pci.ids version" verids
exit(0)

